Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 707258 - dev-libs/efl : fails to build with -fno-common or gcc-10
Summary: dev-libs/efl : fails to build with -fno-common or gcc-10
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Joonas Niilola
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks: -fno-common
  Show dependency tree
 
Reported: 2020-01-29 18:15 UTC by Toralf Förster
Modified: 2020-05-06 09:35 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge-info.txt (emerge-info.txt,16.20 KB, text/plain)
2020-01-29 18:15 UTC, Toralf Förster
Details
dev-libs:efl-1.23.3:20200129-151147.log (dev-libs:efl-1.23.3:20200129-151147.log,96.44 KB, text/plain)
2020-01-29 18:15 UTC, Toralf Förster
Details
emerge-history.txt (emerge-history.txt,107.16 KB, text/plain)
2020-01-29 18:15 UTC, Toralf Förster
Details
environment (environment,97.83 KB, text/plain)
2020-01-29 18:16 UTC, Toralf Förster
Details
etc.portage.tbz2 (etc.portage.tbz2,12.32 KB, application/x-bzip)
2020-01-29 18:16 UTC, Toralf Förster
Details
logs.tbz2 (logs.tbz2,237 bytes, application/x-bzip)
2020-01-29 18:16 UTC, Toralf Förster
Details
temp.tbz2 (temp.tbz2,28.81 KB, application/x-bzip)
2020-01-29 18:16 UTC, Toralf Förster
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Toralf Förster gentoo-dev 2020-01-29 18:15:45 UTC
FAILED: src/benchmarks/eina/eina_bench 
x86_64-pc-linux-gnu-g++  -o src/benchmarks/eina/eina_bench 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_sort.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_hash.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_crc_hash.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_stringshare.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_convert.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_mempool.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_stringshare_e17.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_array.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_rectangle_pool.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/ecore_list.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/ecore_strings.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/ecore_hash.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/ecore_sheap.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/evas_hash.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/evas_list.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/evas_mempool.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/evas_object_list.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/evas_stringshare.c.o' 'src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_quad.c.o' -Wl,--as-needed -Wl,--no-undefined -Wl,-O1 -O2 -pipe -march=native -fno-common -Wl,-O1 -Wl,--as-needed -Wl,--start-group src/benchmarks/eina/libcity.so src/lib/eina/libeina.so.1.23.3 -pthread -ldl -Wl,--end-group '-Wl,-rpath,$ORIGIN/:$ORIGIN/../../lib/eina' -Wl,-rpath-link,/var/tmp/portage/dev-libs/efl-1.23.3/work/efl-1.23.3-build/src/benchmarks/eina -Wl,-rpath-link,/var/tmp/portage/dev-libs/efl-1.23.3/work/efl-1.23.3-build/src/lib/eina
/usr/lib/gcc/x86_64-pc-linux-gnu/9.2.0/../../../../x86_64-pc-linux-gnu/bin/ld: src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_sort.c.o:(.bss+0x0): multiple definition of `key_size'; src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench.c.o:(.bss+0x0): first defined here
/usr/lib/gcc/x86_64-pc-linux-gnu/9.2.0/../../../../x86_64-pc-linux-gnu/bin/ld: src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench_hash.c.o:(.bss+0x0): multiple definition of `key_size'; src/benchmarks/eina/be6b055@@eina_bench@exe/eina_bench.c.o:(.bss+0x0): first defined here

  -------------------------------------------------------------------

  This is an unstable amd64 chroot image at a tinderbox (==build bot)
  name: 17.1_desktop_plasma-libressl-20200126-092715

  -------------------------------------------------------------------

  Please see the tracker bug for details.

gcc-config -l:
 [1] x86_64-pc-linux-gnu-9.2.0 *

clang:
clang version 9.0.1 
Target: x86_64-pc-linux-gnu
Thread model: posix
InstalledDir: /usr/lib/llvm/9/bin
llvm:
9.0.1
Available Python interpreters, in order of preference:
  [1]   python3.8
  [2]   python3.7
  [3]   python3.6
  [4]   python2.7 (fallback)
Available Ruby profiles:
  [1]   ruby24 (with Rubygems)
  [2]   ruby25 (with Rubygems) *
Available Rust versions:
  [1]   rust-1.40.0 *
java-config:
The following VMs are available for generation-2:
*)	IcedTea JDK 3.14.0 [icedtea-bin-8]
Available Java Virtual Machines:
  [1]   icedtea-bin-8  system-vm

repository:
==> /var/db/repos/gentoo/metadata/timestamp.chk <==
Wed, 29 Jan 2020 15:06:24 +0000

emerge -qpvO dev-libs/efl
[ebuild  N    ] dev-libs/efl-1.23.3  USE="X eet gif libressl luajit nls opengl pdf sdl sound ssl svg system-lz4 tiff vnc -bmp -connman -dds -debug -doc -drm -elogind -examples -fbcon -fontconfig -fribidi -gles2 -glib -gnutls -gstreamer -harfbuzz -hyphen -ibus -ico -jpeg2k -json -lua -mono -physics -pmaps -postscript -psd -pulseaudio -raw -scim -static-libs -systemd -tga -tgv -tslib -unwind -v4l -vlc -wayland -webp -xcf -xim -xine -xpm -xpresent -zeroconf"
Comment 1 Toralf Förster gentoo-dev 2020-01-29 18:15:50 UTC
Created attachment 608244 [details]
emerge-info.txt
Comment 2 Toralf Förster gentoo-dev 2020-01-29 18:15:53 UTC
Created attachment 608246 [details]
dev-libs:efl-1.23.3:20200129-151147.log
Comment 3 Toralf Förster gentoo-dev 2020-01-29 18:15:57 UTC
Created attachment 608248 [details]
emerge-history.txt
Comment 4 Toralf Förster gentoo-dev 2020-01-29 18:16:00 UTC
Created attachment 608250 [details]
environment
Comment 5 Toralf Förster gentoo-dev 2020-01-29 18:16:04 UTC
Created attachment 608252 [details]
etc.portage.tbz2
Comment 6 Toralf Förster gentoo-dev 2020-01-29 18:16:10 UTC
Created attachment 608254 [details]
logs.tbz2
Comment 7 Toralf Förster gentoo-dev 2020-01-29 18:16:14 UTC
Created attachment 608256 [details]
temp.tbz2
Comment 8 Larry the Git Cow gentoo-dev 2020-05-04 16:25:02 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=83905dffdbdb042dca4428b9446e09321bf2957d

commit 83905dffdbdb042dca4428b9446e09321bf2957d
Author:     Joonas Niilola <juippis@gentoo.org>
AuthorDate: 2020-05-04 16:14:22 +0000
Commit:     Joonas Niilola <juippis@gentoo.org>
CommitDate: 2020-05-04 16:24:47 +0000

    dev-libs/efl: -fno-common temporary fix
    
    Closes: https://bugs.gentoo.org/707258
    Signed-off-by: Joonas Niilola <juippis@gentoo.org>

 dev-libs/efl/efl-1.23.3.ebuild | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)
Comment 10 Joonas Niilola gentoo-dev 2020-05-05 13:13:12 UTC
I will not touch 1.23.3 with these patches, since it's stabilized and most likely will be cleaned before gcc-10 gets stabilized. This is fixed in the upcoming 1.24.1 release which will also most likely be available before gcc-10. And if not, I'll backport to 1.24.0 which is in portage tree.

This bug does not need to be tracked anymore, but thanks for the comment!
Comment 11 Jeroen Roovers gentoo-dev 2020-05-05 13:59:00 UTC
1.24.0 fails as well.
Comment 12 Jeroen Roovers gentoo-dev 2020-05-05 14:03:51 UTC
Could you stop closing this bug report, please? It needs the exposure.

1.23.* is stable and the likelihood of users being exposed to a combined gcc-10 (or -fno-common in particular) and this version is very small, so working around it by injecting -fcommon (and then closing this bug report) didn't fix the most likely case users would encounter, that of hitting gcc-10 with 1.24.*. So either you need to pointlessly work around the 1.24.0 build failure, too, or you just apply the patches. And then you can close the bug report because nobody will need to search for it again.
Comment 13 Jeroen Roovers gentoo-dev 2020-05-05 14:05:19 UTC
Note: I produced these small patches before I found the exact same ones upstream. They definitely should fix this bug report.
Comment 14 Larry the Git Cow gentoo-dev 2020-05-05 15:24:56 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=cc198b47279beb6bf6677a0f0a5d21ea3f92d183

commit cc198b47279beb6bf6677a0f0a5d21ea3f92d183
Author:     Joonas Niilola <juippis@gentoo.org>
AuthorDate: 2020-05-05 15:24:24 +0000
Commit:     Joonas Niilola <juippis@gentoo.org>
CommitDate: 2020-05-05 15:24:45 +0000

    dev-libs/efl: -fno-common temporary fix
    
    Closes: https://bugs.gentoo.org/707258
    Signed-off-by: Joonas Niilola <juippis@gentoo.org>

 dev-libs/efl/efl-1.24.0.ebuild | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)
Comment 15 Joonas Niilola gentoo-dev 2020-05-05 18:28:57 UTC
Sorry, not meaning to be a d**k here. Just that I expect 1.24.1 to be released before gcc-10 is keyworded in Gentoo, which will have these incorporated. Then I'll remove 1.24.0. So I see no benefit spending more time on 1.24.0 as necessary. It will not be long-lived in Gentoo.
Comment 16 Jeroen Roovers gentoo-dev 2020-05-06 09:30:37 UTC
(In reply to Joonas Niilola from comment #15)
> Sorry, not meaning to be a d**k here. Just that I expect 1.24.1 to be
> released before gcc-10 is keyworded in Gentoo, which will have these
> incorporated. Then I'll remove 1.24.0. So I see no benefit spending more
> time on 1.24.0 as necessary. It will not be long-lived in Gentoo.

That's all fine. The major point I was trying to make is that closing the bug report without fixing both the stable and testing branch would make the bug report nearly invisible to other users having problems on the testing branch (because of the way Bugzilla's default search function "works") and it would probably get you another bug report about 1.24.0 through one of those users or on Toralf's next -fno-common tinderbox run.

Don't forget to remove the flag-o-matic workaround on the 1.24.1 bump, or that will generate another bug report for sure!
Comment 17 Jeroen Roovers gentoo-dev 2020-05-06 09:35:40 UTC
Also note that for 1.24.0, the compiler error is different than what comment #0 shows for src/benchmarks/eina/eina_bench. In 1.24.0 the issue moved to:

/usr/lib/gcc/hppa2.0-unknown-linux-gnu/9.3.0/../../../../hppa2.0-unknown-linux-gnu/bin/ld: src/lib/ecore_evas/41949de@@ecore_evas@sha/ecore_evas_buffer.c.o:/var/tmp/portage/dev-libs/efl-1.24.0/work/efl-1.24.0-build/../efl-1.24.0/src/lib/ecore_evas/ecore_evas_private.h:38: multiple definition of `ecore_evas_request_replaced'; src/lib/ecore_evas/41949de@@ecore_evas@sha/ecore_evas.c.o:/var/tmp/portage/dev-libs/efl-1.24.0/work/efl-1.24.0-build/../efl-1.24.0/src/lib/ecore_evas/ecore_evas_private.h:38: first defined here
[...]